#include "StdAfx.h"
#ifndef _WIN32 
#include "SaraHeaderReader.h"
#else
#include "..\xaira-tools\SaraHeaderReader.h"
#endif
#include "DeclarationManager.h"
#include "xarastruc.h"
#include "MemoryErr.h"

#ifdef _DEBUG
#define mynew ::new(_NORMAL_BLOCK,__FILE__,__LINE__)
#define mydelete ::delete
#else
#define mynew new
#define mydelete delete
#endif

UnicodeString IntToWide(int);

//#define NODM 1

CDeclarationManager::CDeclarationManager():m_list(NULL),m_tail(&m_list),m_bInBib(false),m_nw(0),
	m_thistext(NULL)
{
	m_uu=mynew int [m_ub.GetRangeCount()];
	memset(m_uu,0,m_ub.GetRangeCount()*sizeof (int));
}

CDeclarationManager::~CDeclarationManager(void)
{
	mydelete [] m_uu;
	dm_declaration* d=m_list;
	while (d) {
		dm_declaration* dd=d->next;
		switch (d->ty) {
			case DMT_ELEMENT:
				mydelete (dm_element*) d;
				break;
			case DMT_ATTRIBUTE:
				mydelete (dm_attribute*) d;
				break;
			case DMT_ATTVAL:
				mydelete (dm_value*) d;
				break;
			case DMT_INTENT:
				mydelete (dm_intent*) d;
				break;
			case DMT_ADDKEY:
				mydelete (dm_addkey*) d;
				break;
			case DMT_ADDKEYVAL:
				mydelete (dm_addkeyvalue*) d;
				break;
			case DMT_NAMESPACE:
				mydelete (dm_namespace*) d;
				break;
		}
		d=dd;
	}
}

#define MAXV 100
#define MAXVA 1000


void CDeclarationManager::DeclareAddkey(UnicodeString k,UnicodeString val)
{
#ifdef NODM
	return;
#endif
	dm_addkey* da=NULL;
	_addkey* ak=NULL;
	_tagusage* t=NULL; 
	_attusage* at=NULL; 
	if (da=AddkeyDeclared(k)) goto declare_value;
	da=mynew dm_addkey;
	da->k=k;
	da->ty=DMT_ADDKEY;
	int i;
	for (i=1;i<m_header->m_naddkeys;i++) {
		ak=&m_header->m_addkeys[i];
		if (ak->name==k) break;
	}
	if (i==m_header->m_naddkeys) return;
	da->gloss=ak->desc;
	da->isPseudo=ak->isPseudo;
	da->isLemma=ak->isLemma;
	da->att=ak->att;
	da->ngi=ak->ngi;
	da->gi=ak->gi;
	da->defval=ak->defval;
	da->dproc=ak->dproc;
	da->nv=0;
	da->idx=i-1;
	da->bCB=!ak->isLemma;
	int j;
	for (j=0;j<m_header->m_ntags;j++) {
		t=&m_header->m_tagusage[j];
		if (t->name==ak->gi[0]) break;
	}
	if (ak->ngi > 0 && j==m_header->m_ntags) return;
	if (!ak->isPseudo) {
		int kk;
		for (kk=0;kk<t->natts;kk++) {
			at=&t->atts[kk];
			if (at->name==ak->att) break;
		}
		if (kk==t->natts) return;
		da->ncb=at->nc;
		da->cb=at->cb;
	}
	else da->cb=NULL;
	Add(da);
	if (!ak->isPseudo) DeclareAttribute(t->name,t->uri,at->name,"","",false);
declare_value:
	if (!da->bCB) return;
	if (da->nv > MAXVA) return;
	dm_addkeyvalue* dv=NULL;
	if (dv=AddkeyValueDeclared(da,val)) {dv->n++; return;}
	dv=mynew dm_addkeyvalue;
	dv->ty=DMT_ADDKEYVAL;
	dv->a=da;
	dv->v=val;
	dv->n=1;
	if (da->cb) {
		for (int i=0;i<da->ncb;i++) {
			_code* c=&da->cb[i];
			if (c->code==val) dv->gloss=c->desc;
		}
	}
	da->nv++;
	Add(dv);
}


void CDeclarationManager::DeclareElement(UnicodeString e,UnicodeString uri)
{
#ifdef NODM
	return;
#endif
	DeclareNamespace(uri);
	dm_element* de=NULL;
	if (de=ElementDeclared(e,uri)) {
		if (m_bInBib) de->bBib=true;
		return;
	}		
	de=mynew dm_element;
	de->e=e;
	de->uri=uri;
	de->ty=DMT_ELEMENT;
	de->bBib=m_bInBib;
	for (int i=0;i<m_header->m_ntags;i++) {
		_tagusage* t=&m_header->m_tagusage[i];
		if (t->name==e && t->uri==uri) {
			de->gloss=t->gloss;
			break;
		}
	}
	Add(de);
}

void CDeclarationManager::Add(dm_declaration* d)
{
	d->next=NULL;
	(*m_tail)=d;
	m_tail=&d->next;
}

void CDeclarationManager::DeclareAttribute(UnicodeString e, UnicodeString uri, UnicodeString a, UnicodeString uria,UnicodeString val,bool bG)
{
#ifdef NODM
	return;
#endif
	DeclareNamespace(uri);
	DeclareNamespace(uria);
	if (uria==UnicodeString(XAIRA_URI)) return;
	dm_attribute* da=NULL;
	_attusage* at=NULL; 
	_attusage* at0=NULL; 
	int i; 
	if (da=AttributeDeclared(e,uri,a,uria,bG)) goto declare_value;
	if (!bG) {
		for (int i=0;i<m_header->m_ntags;i++) {
			_tagusage* t=&m_header->m_tagusage[i];
			if (t->name != e || t->uri != uri) continue;
			int j; _attusage* at0;
			for (j=0; j<t->natts;j++) {
				at0=&t->atts[j];
				if (at0->name==a && at0->uri==uria) break;
			}
			if (j < t->natts) {
				at=at0;
				break;
			}
		}
	}
	else {
		for (i=0;i<m_header->m_nglobatts;i++) {
			at0=&m_header->m_globals[i];
			if (at0->name==a && at0->uri==uria) {
				at=at0;
				break;
			}
		}
	}

	da=mynew dm_attribute;
	da->a=a;
	da->uria=uria;
	da->ty=DMT_ATTRIBUTE;
	da->bBib=m_bInBib;
	da->bG=bG;
	da->nv=0;
	if (!bG) {
	da->e=e;
	da->uri=uri;
	}
	if (at) {
		da->ip=at->ip;
		da->bCB=at->bCB;
		da->gloss=at->gloss;
		da->target=at->target;
		da->ncb=at->nc;
		da->cb=at->cb;
	} else {
		da->ip=IP_CDATA;
		da->bCB=false;
	}
	Add(da);
declare_value:
	if (m_bInBib) da->bBib=true;
	if (!da->bCB) return;
	if (da->nv > MAXV) {
		da->bCB=false;
		return;
	}
	if (ValueDeclared(da,val)) return;
	da->nv++;
	dm_value* dv=mynew dm_value;
	dv->ty=DMT_ATTVAL;
	dv->a=da;
	dv->v=val;
	for (int i=0;i<da->ncb;i++) {
		_code* c=&da->cb[i];
		if (c->code==val) dv->gloss=c->desc;
	}
	Add(dv);
}

void CDeclarationManager::DeclareCharacters(UnicodeString c)
{
#ifdef NODM
	return;
#endif
	for (int i=0;i<c.length();i++) {
		int k=m_ub.Classify(c[i]);
		if (k >= 0) m_uu[k]=1;
	}
}

void CDeclarationManager::DeclareNamespace(UnicodeString uri)
{
#ifdef NODM
	return;
#endif
	if (NamespaceDeclared(uri)) return;
	dm_namespace* dn=mynew dm_namespace;
	dn->uri=uri;
	dn->ty=DMT_NAMESPACE;
	Add(dn);
}

UnicodeString CDeclarationManager::CorpusTextName(UnicodeString s)
{
	if (!CorpusTextDeclared(s)) return s;
	for (int i=0;;i++) {
		UnicodeString a=IntToWide(i);
		UnicodeString x=s;
		x.append(s);
		if (!CorpusTextDeclared(x)) return x;
	}
}

void CDeclarationManager::DeclareCorpusText(UnicodeString name,int nw,int* nr)
{
#ifdef NODM
	return;
#endif
	if (m_thistext) {
		m_thistext->w=nw-m_nw;
		m_thistext->nr=nr;
	}
	m_nw=nw;
	if (name.isEmpty()) return;
	if (CorpusTextDeclared(name)) return;
	dm_corpustext* dct=mynew dm_corpustext;
	dct->name=name;
	dct->ty=DMT_CORPUSTEXT;
	dct->classes=new int[m_header->m_ntax];
	dct->elts=new UnicodeString[m_header->m_ntax];
	dct->atts=new UnicodeString[m_header->m_ntax];
	for (int i=0;i<m_header->m_ntax;i++) {
		dct->classes[i]=-1;
	}
	Add(dct);
	m_thistext=dct;
}

void CDeclarationManager::DeclareClass(int i,int p,UnicodeString e,UnicodeString n)
{
	m_thistext->classes[i]=p;
	m_thistext->elts[i]=e;
	m_thistext->atts[i]=n;
}

void CDeclarationManager::DeclareInternalEntity(UnicodeString e, UnicodeString v)
{
#ifdef NODM
	return;
#endif
	if (InternalEntityDeclared(e)) return;
	dm_intent* de=mynew dm_intent;
	de->e=e;
	de->v=v;
	de->ty=DMT_INTENT;
	Add(de);
}

void CDeclarationManager::DeclareAttributeValue(UnicodeString v)
{
	// data needed - value, gloss, elt, name
}

dm_element* CDeclarationManager::ElementDeclared(UnicodeString e, UnicodeString uri)
{
	dm_declaration* d=m_list;
	while (d) {
		if (d->ty == DMT_ELEMENT) {
			dm_element* de=(dm_element*) d;
			if (de->e==e) { de->freq++; return de;}
		}
		d=d->next;
	}
	return NULL;
}

dm_namespace* CDeclarationManager::NamespaceDeclared(UnicodeString uri)
{
	dm_declaration* d=m_list;
	while (d) {
		if (d->ty == DMT_NAMESPACE) {
			dm_namespace* dn=(dm_namespace*) d;
			if (dn->uri==uri) {dn->freq++; return dn;}
		}
		d=d->next;
	}
	return NULL;
}

dm_corpustext* CDeclarationManager::CorpusTextDeclared(UnicodeString name)
{
	dm_declaration* d=m_list;
	while (d) {
		if (d->ty == DMT_CORPUSTEXT) {
			dm_corpustext* dn=(dm_corpustext*) d;
			if (dn->name==name) {dn->freq++; return dn;}
		}
		d=d->next;
	}
	return NULL;
}


dm_value* CDeclarationManager::ValueDeclared(dm_attribute* a, UnicodeString v)
{
	dm_declaration* d=m_list;
	while (d) {
		if (d->ty == DMT_ATTVAL) {
			dm_value* dv=(dm_value*) d;
			if (dv->a==a && dv->v==v) {dv->freq++; return dv;}
		}
		d=d->next;
	}
	return NULL;
}

dm_addkeyvalue* CDeclarationManager::AddkeyValueDeclared(dm_addkey* a, UnicodeString v)
{
	dm_declaration* d=m_list;
	while (d) {
		if (d->ty == DMT_ADDKEYVAL) {
			dm_addkeyvalue* dv=(dm_addkeyvalue*) d;
			if (dv->a==a && dv->v==v) {dv->freq++;return dv;}
		}
		d=d->next;
	}
	return NULL;
}

bool CDeclarationManager::InternalEntityDeclared(UnicodeString e)
{
	dm_declaration* d=m_list;
	while (d) {
		if (d->ty == DMT_INTENT) {
			dm_intent* de=(dm_intent*) d;
			if (de->e==e) {de->freq++; return true;}
		}
		d=d->next;
	}
	return false;
}

dm_attribute* CDeclarationManager::AttributeDeclared(UnicodeString e, UnicodeString uri,UnicodeString a,UnicodeString uria,bool bG)
{
	dm_declaration* d=m_list;
	while (d) {
		if (d->ty == DMT_ATTRIBUTE) {
			dm_attribute* da=(dm_attribute*) d;
			if (da->a==a && da->uria==uria && da->bG==bG && (da->bG ||
				da->e==e && da->uria==uria)) {da->freq++; return da;}
		}
		d=d->next;
	}
	return NULL;
}

dm_addkey* CDeclarationManager::AddkeyDeclared(UnicodeString e)
{
	dm_declaration* d=m_list;
	while (d) {
		if (d->ty == DMT_ADDKEY) {
			dm_addkey* da=(dm_addkey*) d;
			if (da->k==e) {da->freq++; return da;}
		}
		d=d->next;
	}
	return NULL;
}


void CDeclarationManager::DSCLabels(FILE* f)
{
	for (int i=0;i<m_header->m_nlabels;i++) {
		_lab* l=&m_header->m_labels[i];
		if (l->isSpec) {
			switch(l->e) {
			case SPE_LINE:
				fwprintf(f,L("label #LINE #AUTO\r\n"));
				break;
			case SPE_FILE:
				fwprintf(f,L("label #FILE #AUTO\r\n"));
				break;
			}
		} else if (l->isAuto) {
			fwprintf(f,L("label %s #AUTO\r\n"),l->elt[0].getTerminatedBuffer());
		} else 
			fwprintf(f,L("label %s %s\r\n"),l->elt[0].getTerminatedBuffer(),l->att.getTerminatedBuffer());
	}
}


static UChar s_labels[]={'l','a','b','e','l','s',0};
static UChar s_label[]={'l','a','b','e','l',0};
static UChar s_element[]={'e','l','e','m','e','n','t',0};
static UChar s_elements[]={'e','l','e','m','e','n','t','s',0};
static UChar s_attribute[]={'a','t','t','r','i','b','u','t','e',0};
static UChar s_hash_LINE[]={'#','L','I','N','E',0};
static UChar s_hash_AUTO[]={'#','A','U','T','O',0};
static UChar s_hash_FILE[]={'#','F','I','L','E',0};

void CDeclarationManager::GrammarLabels(DOMElement* e)
{
	DOMElement* le=m_doc->createElementNS(XAIRA_URIL,s_labels);
	e->appendChild(le);
	for (int i=0;i<m_header->m_nlabels;i++) {
		_lab* l=&m_header->m_labels[i];
		DOMElement* lab=m_doc->createElementNS(XAIRA_URIL,s_label);
		Ident(lab);
		le->appendChild(lab);
		if (l->isSpec) {
			switch(l->e) {
			case SPE_LINE:
				lab->setAttributeNS(XAIRA_URIL,s_element,s_hash_LINE);
				lab->setAttributeNS(XAIRA_URIL,s_attribute,s_hash_AUTO);
				break;
			case SPE_FILE:
				lab->setAttributeNS(XAIRA_URIL,s_element,s_hash_FILE);
				lab->setAttributeNS(XAIRA_URIL,s_attribute,s_hash_AUTO);
				break;
			}
		} else if (l->isAuto) {
			lab->setAttributeNS(XAIRA_URIL,s_element,(const xairo_uchar*) l->elt[0].getTerminatedBuffer());
			lab->setAttributeNS(XAIRA_URIL,s_attribute,s_hash_AUTO);
		} else {
			lab->setAttributeNS(XAIRA_URIL,s_element,(const xairo_uchar*) l->elt[0].getTerminatedBuffer());
			lab->setAttributeNS(XAIRA_URIL,s_attribute,(const xairo_uchar*) l->att.getTerminatedBuffer());
		}
	}
}

void CDeclarationManager::DSCAddKeys(FILE* f)
{
	for (int i=0;i<m_header->m_nwtags;i++) {
		fwprintf(f,L("wtag %s\r\n"),m_header->m_wtags[i].s.getTerminatedBuffer());
	}
	dm_addkey** l;
	int k=GetAddkeyList(l);
	for (int ii=0;ii<k;ii++) {
		if (l[ii]->isLemma) 
			fwprintf(f,L("lemmata %s %s\r\n"),l[ii]->k.getTerminatedBuffer(),l[ii]->gloss.getTerminatedBuffer());
		else {
			fwprintf(f,L("catt %s %d %s\r\n"),l[ii]->k.getTerminatedBuffer(),l[ii]->idx,l[ii]->att.getTerminatedBuffer());
/*		if (l[ii]->isPseudo) {
				for (int i=0;i<l[ii]->ngi;i++) {
					fwprintf(f,L("pos %s %s 0 %s\r\n"),l[ii]->k.getTerminatedBuffer(),
						l[ii]->gi[i].getTerminatedBuffer(),l[ii]->gi[i].getTerminatedBuffer());
				}
				fwprintf(f,L("pos %s %s 0 %s\r\n"),l[ii]->k.getTerminatedBuffer(),l[ii]->defval.getTerminatedBuffer(),l[ii]->defval.getTerminatedBuffer());

			}
			else
*/				DSCAddkeyValues(f,l[ii]);
			}
		}
	
	mydelete [] l;
}


static UChar s_wtags[]={'w','t','a','g','s',0};
static UChar s_wtag[]={'w','t','a','g',0};
static UChar s_gi[]={'g','i',0};
static UChar s_addkeys[]={'a','d','d','k','e','y','s',0};
static UChar s_addkey[]={'a','d','d','k','e','y',0};
static UChar s_name[]={'n','a','m','e',0};
static UChar s_lemma[]={'l','e','m','m','a',0};
static UChar s_yes[]={'y','e','s',0};
static UChar s_gloss[]={'g','l','o','s','s',0};
static UChar s_freq[]={'f','r','e','q',0};

xairo_uchar g_nb[10]; 

void CDeclarationManager::GrammarAddKeys(DOMElement* e)
{
	DOMElement* w=m_doc->createElementNS(XAIRA_URIL,s_wtags);
	e->appendChild(w);
	for (int i=0;i<m_header->m_nwtags;i++) {
		DOMElement* wt=m_doc->createElementNS(XAIRA_URIL,s_wtag);
		Ident(wt);
		w->appendChild(wt);
		wt->setAttributeNS(XAIRA_URIL,s_gi,(const xairo_uchar*) m_header->m_wtags[i].s.getTerminatedBuffer());
	}
	dm_addkey** l;
	int k=GetAddkeyList(l);
	DOMElement* ak=m_doc->createElementNS(XAIRA_URIL,s_addkeys);
	e->appendChild(ak);
	for (int ii=0;ii<k;ii++) {
		DOMElement* akey=m_doc->createElementNS(XAIRA_URIL,s_addkey);
		Ident(akey);
		ak->appendChild(akey);
		akey->setAttributeNS(XAIRA_URIL,s_name,(const xairo_uchar*) l[ii]->k.getTerminatedBuffer());
        if (l[ii]->isLemma) 
			akey->setAttributeNS(XAIRA_URIL,s_lemma,s_yes);
		akey->setAttributeNS(XAIRA_URIL,s_freq,_itow(l[ii]->freq,g_nb,10));
		akey->setAttributeNS(XAIRA_URIL,s_gloss,(const xairo_uchar*) l[ii]->gloss.getTerminatedBuffer());
		akey->setAttributeNS(XAIRA_URIL,s_attribute,(const xairo_uchar*) l[ii]->att.getTerminatedBuffer());
		GrammarAddkeyValues(akey,l[ii]);
//			if (l[ii]->dproc==_addkey::DP_USEVAL) {
//				fwprintf(f,L"pos %s %s %s\r\n",l[ii]->k.getTerminatedBuffer(),
//					l[ii]->defval.getTerminatedBuffer(),l[ii]->defval.getTerminatedBuffer());
//			}
//		}
	}
	mydelete [] l;
}

void CDeclarationManager::DSCElements(FILE* f)
{
	dm_element** le;
	dm_attribute** la;
	int ka=GetAttributesList("","",la);
	for (int i=0;i<ka;i++) {
		DSCAttribute(f,la[i]);
	}
	mydelete [] la;
	int ke=GetElementList(le);
	for (int i=0;i<ke;i++) {
		const char* url=Ascii(le[i]->uri.getTerminatedBuffer());
		if (url[0]==0) url="/";   
		fwprintf(f,L("elt %s %S b %s\r\n"),le[i]->e.getTerminatedBuffer(),url,le[i]->gloss.getTerminatedBuffer());
		ka=GetAttributesList(le[i]->e,le[i]->uri,la);
		for (int j=0;j<ka;j++) {
			DSCAttribute(f,la[j]);
		}
		mydelete [] la;
	}
	mydelete [] le;
}


static UChar s_namespaces[]={'n','a','m','e','s','p','a','c','e','s',0};
static UChar s_namespace[]={'n','a','m','e','s','p','a','c','e',0};
static UChar s_uri[]={'u','r','i',0};

void CDeclarationManager::GrammarNamespaces(DOMElement* e)
{
	dm_namespace **ln;
	int kn=GetNamespaceList(ln);
	DOMElement* ns=m_doc->createElementNS(XAIRA_URIL,s_namespaces);
	e->appendChild(ns);
	for (int i=0;i<kn;i++) {
		DOMElement* n=m_doc->createElementNS(XAIRA_URIL,s_namespace);
		Ident(n);
		n->setAttributeNS(XAIRA_URIL,s_uri,(const xairo_uchar*) ln[i]->uri.getTerminatedBuffer());
		n->setAttributeNS(XAIRA_URIL,s_freq,_itow(ln[i]->freq,g_nb,10));
		ns->appendChild(n);
	}
//	mydelete *ln;
}

UChar s_globals[]={'g','l','o','b','a','l','s',0};
UChar s_ns[]={'n','s',0};
UChar s_bib[]={'b','i','b',0};

void CDeclarationManager::GrammarElements(DOMElement* e)
{
	dm_element** le;
	dm_attribute** la;
	int ka=GetAttributesList("","",la);
	DOMElement* els=m_doc->createElementNS(XAIRA_URIL,s_elements);
	e->appendChild(els);
	DOMElement* gs=m_doc->createElementNS(XAIRA_URIL,s_globals);
	els->appendChild(gs);
	for (int i=0;i<ka;i++) {
		GrammarAttribute(gs,la[i]);
	}
	mydelete [] la;
	int ke=GetElementList(le);
	for (int i=0;i<ke;i++) {
		DOMElement* el=m_doc->createElementNS(XAIRA_URIL,s_element);
		Ident(el);
		el->setAttributeNS(XAIRA_URIL,s_name,(const xairo_uchar*) le[i]->e.getTerminatedBuffer());
		el->setAttributeNS(XAIRA_URIL,s_freq,_itow(le[i]->freq,g_nb,10));
		el->setAttributeNS(XAIRA_URIL,s_gloss,(const xairo_uchar*) le[i]->gloss.getTerminatedBuffer());
		if (!le[i]->uri.isEmpty())
			el->setAttributeNS(XAIRA_URIL,s_ns,(const xairo_uchar*) le[i]->uri.getTerminatedBuffer());
		if (le[i]->bBib) 
			el->setAttributeNS(XAIRA_URIL,s_bib,s_yes);
		els->appendChild(el);
		ka=GetAttributesList(le[i]->e,le[i]->uri,la);
		for (int j=0;j<ka;j++) {
			GrammarAttribute(el,la[j]);
		}
		mydelete [] la;
	}
	mydelete [] le;
}


void CDeclarationManager::DSCBibElements(FILE* f)
{
	dm_element** le;
	dm_attribute** la;
	int ke=GetElementList(le);
	for (int i=0;i<ke;i++) {
		if (!le[i]->bBib) continue;
		fwprintf(f,L("eltb %s\r\n"),le[i]->e.getTerminatedBuffer());
		int ka=GetAttributesList(le[i]->e,le[i]->uri,la);
		for (int j=0;j<ka;j++) {
			fwprintf(f,L("attb %s\r\n"),la[j]->a.getTerminatedBuffer());
		}
		mydelete [] la;
	}
	mydelete [] le;

}


static UChar s_bibelements[]={'b','i','b','e','l','e','m','e','n','t','s',0};

void CDeclarationManager::DSCAttribute(FILE* f,dm_attribute* da)
{
	const char* url=Ascii(da->uria.getTerminatedBuffer());
	if (url[0]==0) url="/";   
	switch (da->ip) {
		case IP_CONTENTA:
			fwprintf(f,L("att %s %S CATT 0 %s\r\n"),da->a.getTerminatedBuffer(),url,da->gloss.getTerminatedBuffer());
			break;
		case IP_ID:
			fwprintf(f,L("att %s %S ID 0 %s\r\n"),da->a.getTerminatedBuffer(),url,da->gloss.getTerminatedBuffer());
			break;
		case IP_IDREF:
			fwprintf(f,L("att %s %S IDREF %s %s\r\n"),da->a.getTerminatedBuffer(),url,da->target.getTerminatedBuffer(),da->gloss.getTerminatedBuffer());
			break;
		case IP_CDATA:
			fwprintf(f,L("att %s %S CDATA 0 %s\r\n"),da->a.getTerminatedBuffer(),url,da->gloss.getTerminatedBuffer());
			if (da->bCB) DSCValues(f,da);
			break;
		case IP_TAX:
			DSCTaxonomy(f,da);
			break;
		default:
			fwprintf(f,L("att %s %S CDATA 0\r\n"),da->a.getTerminatedBuffer(),url);
	}
}


static UChar s_ip[]={'i','p',0};
static UChar s_target[]={'t','a','r','g','e','t',0};
static UChar s_ID[]={'I','D',0};
static UChar s_IDREF[]={'I','D','R','E','F',0};
static UChar s_CDATA[]={'C','D','A','T','A',0};

void CDeclarationManager::GrammarAttribute(DOMElement* e,dm_attribute* da)
{
	DOMElement* a=m_doc->createElementNS(XAIRA_URIL,s_attribute);
	Ident(a);
	e->appendChild(a);
	a->setAttributeNS(XAIRA_URIL,s_name,(const xairo_uchar*) da->a.getTerminatedBuffer());
	a->setAttributeNS(XAIRA_URIL,s_freq,_itow(da->freq,g_nb,10));
	a->setAttributeNS(XAIRA_URIL,s_gloss,(const xairo_uchar*) da->gloss.getTerminatedBuffer());
	if (da->bBib) a->setAttributeNS(XAIRA_URIL,s_bib,s_yes);
	if (!da->uria.isEmpty())
			a->setAttributeNS(XAIRA_URIL,s_ns,(const xairo_uchar*) da->uria.getTerminatedBuffer());
	switch (da->ip) {
		case IP_ID:
			a->setAttributeNS(XAIRA_URIL,s_ip,s_ID);
			break;
		case IP_IDREF:
			a->setAttributeNS(XAIRA_URIL,s_ip,s_IDREF);
			a->setAttributeNS(XAIRA_URIL,s_target,(const xairo_uchar*) da->target.getTerminatedBuffer());
			break;
		case IP_CDATA:
			a->setAttributeNS(XAIRA_URIL,s_ip,s_CDATA);
			if (da->bCB) GrammarValues(a,da);
			break;
		case IP_TAX:
			GrammarTaxonomy(e,da->a);
			break;
	}
}

static UChar s_MULTIDREFS[]={'M','U','L','T','I','D','R','E','F','S',0};
static UChar s_menu[]={'m','e','n','u',0};
static UChar s_item[]={'i','t','e','m',0};
static UChar s_desc[]={'d','e','s','c',0};
static UChar s_taxid[]={'t','a','x','i','d',0};
static UChar s_id[]={'i','d',0};


void CDeclarationManager::GrammarTaxonomy(DOMElement* e,UnicodeString name)
{
	for (int i=0;i<m_header->m_ntax;i++) {
		_taxonomy* t=&m_header->m_taxonomies[i];
		DOMElement* a=m_doc->createElementNS(XAIRA_URIL,s_attribute);
		Ident(a);
		e->appendChild(a);
		a->setAttributeNS(XAIRA_URIL,s_name,(const xairo_uchar*) name.getTerminatedBuffer());
		a->setAttributeNS(XAIRA_URIL,s_ip,s_MULTIDREFS);
		a->setAttributeNS(XAIRA_URIL,s_taxid,(const xairo_uchar*) t->id.getTerminatedBuffer());
		DOMElement* m=m_doc->createElementNS(XAIRA_URIL,s_menu);
		Ident(m);
		a->appendChild(m);
		_class* l=t->l;
		for (int j=0;j<t->n;j++) {
			_class* c=&l[j];
			DOMElement* ci=m_doc->createElementNS(XAIRA_URIL,s_item);
			Ident(ci);
			m->appendChild(ci);
			ci->setAttributeNS(XAIRA_URIL,s_taxid,(const xairo_uchar*) c->id.getTerminatedBuffer());
			ci->setAttributeNS(XAIRA_URIL,s_desc,(const xairo_uchar*) c->desc.getTerminatedBuffer());
		}
	}
}

void CDeclarationManager::DSCTaxonomy(FILE* f,dm_attribute *da)
{
	for (int i=0;i<m_header->m_ntax;i++) {
		_taxonomy* t=&m_header->m_taxonomies[i];
		UnicodeString e,n;
		bool b=IsClassTag(i,da->e,da->a);
		if (!b) continue;
		fwprintf(f,L("att %s / MULTIDREFS %s %s\r\n"),da->a.getTerminatedBuffer(),t->id.getTerminatedBuffer(),t->id.getTerminatedBuffer());
		fwprintf(f,L("menu 0 %s\r\n"),t->desc.getTerminatedBuffer());
		_class* l=t->l;
		for (int j=0;j<t->n;j++) {
			_class* c=&l[j];
			fwprintf(f,L("item %s %s\r\n"),c->id.getTerminatedBuffer(),c->desc.getTerminatedBuffer());
		}
	}
}


bool CDeclarationManager::IsClassTag(int j,UnicodeString e,UnicodeString n)
{
	dm_corpustext** t;
	int k=GetCorpusTextList(t);
	for (int i=0;i<k;i++) {
		if (e==t[i]->elts[j] && n==t[i]->atts[j]) return true;
	}
	return false;
}


void CDeclarationManager::DSCTaxonomies(FILE* f)
{
	for (int i=0;i<m_header->m_ntax;i++) {
		_taxonomy* t=&m_header->m_taxonomies[i];
		fwprintf(f,L("tax %s %s\r\n"),t->id.getTerminatedBuffer(),t->desc.getTerminatedBuffer());
		_class* l=t->l;
		for (int j=0;j<t->n;j++) {
			_class* c=&l[j];
			fwprintf(f,L("taxcode %s %s\r\n"),c->id.getTerminatedBuffer(),c->desc.getTerminatedBuffer());
		}
		fwprintf(f,L("taxcode %s %s\r\n"),t->unclass.getTerminatedBuffer(),t->unclass.getTerminatedBuffer());

	}
}

static UChar s_lemmaschemes[]={'l','e','m','m','a','s','c','h','e','m','e','s',0};
static UChar s_lemmascheme[]={'l','e','m','m','a','s','c','h','e','m','e',0};
static UChar s_key[]={'k','e','y',0};

void CDeclarationManager::GrammarLemmaSchemes(DOMElement* e)
{
	DOMElement* ls=m_doc->createElementNS(XAIRA_URIL,s_lemmaschemes);
	e->appendChild(ls);
	for (int i=0;i<m_header->m_nls;i++) {
		_ls* l=&m_header->m_ls[i];
		DOMElement* ls0=m_doc->createElementNS(XAIRA_URIL,s_lemmascheme);
		Ident(ls0);
		ls->appendChild(ls0);
		ls0->setAttributeNS(XAIRA_URIL,s_name,(const xairo_uchar*) l->name.getTerminatedBuffer());
		ls0->setAttributeNS(XAIRA_URIL,s_gloss,(const xairo_uchar*) l->desc.getTerminatedBuffer());
		for (int j=0;j<l->n;j++) {
			DOMElement* ls1=m_doc->createElementNS(XAIRA_URIL,s_key);
			ls0->appendChild(ls1);
			ls1->setAttributeNS(XAIRA_URIL,s_name,l->a[j].getTerminatedBuffer());
		}
	}
}

void CDeclarationManager::DSCLemmaSchemes(FILE* f)
{
	for (int i=0;i<m_header->m_nls;i++) {
		_ls* l=&m_header->m_ls[i];
		fwprintf(f,L("ls %s %s\r\n"),l->name.getTerminatedBuffer(),l->desc.getTerminatedBuffer());
		for (int j=0;j<l->n;j++) {
			fwprintf(f,L("key %s\r\n"),l->a[j].getTerminatedBuffer());
		}
	}
}

static UChar s_regions[]={'r','e','g','i','o','n','s',0};
static UChar s_region[]={'r','e','g','i','o','n',0};
static UChar s_value[]={'v','a','l','u','e',0};
static UChar s_pc_04x[]={'%','0','4','x',0};

void CDeclarationManager::GrammarRegions(DOMElement* e)
{
	DOMElement* ls=m_doc->createElementNS(XAIRA_URIL,s_regions);
	e->appendChild(ls);
	for (int i=0;i<m_header->m_nreg;i++) {
		_region* l=&m_header->m_reg[i];
		DOMElement* ls0=m_doc->createElementNS(XAIRA_URIL,s_region);
		Ident(ls0);
		ls->appendChild(ls0);
		ls0->setAttributeNS(XAIRA_URIL,s_name,(const xairo_uchar*) l->name.getTerminatedBuffer());
		ls0->setAttributeNS(XAIRA_URIL,s_gloss,(const xairo_uchar*) l->desc.getTerminatedBuffer());
		xairo_uchar wx[10];
		_snwprintf(wx,10,s_pc_04x,l->nak);
		ls0->setAttributeNS(XAIRA_URIL,s_addkey,wx);
		for (int j=0;j<l->n;j++) {
			DOMElement* ls1=m_doc->createElementNS(XAIRA_URIL,s_value);
			ls0->appendChild(ls1);
			ls1->setAttributeNS(XAIRA_URIL,s_name,l->a[j].getTerminatedBuffer());
		}
	}
}


void CDeclarationManager::DSCRegions(FILE* f)
{
	for (int i=0;i<m_header->m_nreg;i++) {
		_region* r=&m_header->m_reg[i];
		if (r->nak < 0) continue;
		UnicodeString ak=m_header->m_addkeys[r->nak].name;
		fwprintf(f,L("region %s %s\r\n"),r->name.getTerminatedBuffer(),ak.getTerminatedBuffer(),r->desc.getTerminatedBuffer());
		for (int j=0;j<r->n;j++) {
			fwprintf(f,L("rval %s\r\n"),r->a[j].getTerminatedBuffer());
		}
	}
}
static UChar s_taxonomies[]={'t','a','x','o','n','o','m','i','e','s',0};
static UChar s_taxonomy[]={'t','a','x','o','n','o','m','y',0};
static UChar s_class[]={'c','l','a','s','s',0};
static UChar s_root[]={'r','o','o','t',0};

void CDeclarationManager::GrammarTaxonomies(DOMElement* e)
{
	DOMElement* tx=m_doc->createElementNS(XAIRA_URIL,s_taxonomies);
	e->appendChild(tx);
	DOMElement* txr=m_doc->createElementNS(XAIRA_URIL,s_taxonomy);
	Ident(txr);
	tx->appendChild(txr);
	txr->setAttributeNS(XAIRA_URIL,s_desc,s_root);
	for (int i=0;i<m_header->m_ntax;i++) {
		_taxonomy* t=&m_header->m_taxonomies[i];
		DOMElement* tn=m_doc->createElementNS(XAIRA_URIL,s_taxonomy);
		Ident(tn);
		txr->appendChild(tn);
		tn->setAttributeNS(XAIRA_URIL,s_taxid,(const xairo_uchar*) t->id.getTerminatedBuffer());
		tn->setAttributeNS(XAIRA_URIL,s_desc,(const xairo_uchar*) t->desc.getTerminatedBuffer());
		_class* l=t->l;
		for (int j=0;j<t->n;j++) {
			_class* c=&l[j];
			DOMElement* cl=m_doc->createElementNS(XAIRA_URIL,s_class);
			Ident(cl);
			tn->appendChild(cl);
			cl->setAttributeNS(XAIRA_URIL,s_taxid,(const xairo_uchar*) c->id.getTerminatedBuffer());
			cl->setAttributeNS(XAIRA_URIL,s_desc,(const xairo_uchar*) c->desc.getTerminatedBuffer());
		}
		DOMElement* cl=m_doc->createElementNS(XAIRA_URIL,s_class);
		Ident(cl);
		tn->appendChild(cl);
		cl->setAttributeNS(XAIRA_URIL,s_taxid,(const xairo_uchar*) t->unclass.getTerminatedBuffer());
		cl->setAttributeNS(XAIRA_URIL,s_desc,(const xairo_uchar*) t->unclass.getTerminatedBuffer());

	}
}

void CDeclarationManager::DSCValues(FILE* f,dm_attribute* da)
{
	dm_value** l;
	int k=GetValueList(da,l);
	if (k==0) return;
	UnicodeString t=da->a;
	if (t.isEmpty()) t=da->a;
	fwprintf(f,L("menu 0 %s\r\n"),(const xairo_uchar*) t.getTerminatedBuffer());
	for (int jj=0;jj<k;jj++) {
		UnicodeString s=l[jj]->gloss;
		if (s.isEmpty()) s=l[jj]->v;
		fwprintf(f,L("item %s %s\r\n"),l[jj]->v.getTerminatedBuffer(),s.getTerminatedBuffer());
	}
}


static UChar s_codebook[]={'c','o','d','e','b','o','o','k',0};
static UChar s_code[]={'c','o','d','e',0};

void CDeclarationManager::GrammarValues(DOMElement* e,dm_attribute* da)
{
	dm_value** l;
	int k=GetValueList(da,l);
	if (k==0) return;
	DOMElement* cb=m_doc->createElementNS(XAIRA_URIL,s_codebook);
	Ident(cb);
	e->appendChild(cb);
	for (int jj=0;jj<k;jj++) {
		DOMElement* c=m_doc->createElementNS(XAIRA_URIL,s_code);
		Ident(c);
		cb->appendChild(c);
		c->setAttributeNS(XAIRA_URIL,s_name,(const xairo_uchar*) l[jj]->v.getTerminatedBuffer());
		c->setAttributeNS(XAIRA_URIL,s_freq,_itow(l[jj]->freq,g_nb,10));
		UnicodeString s=l[jj]->gloss;
		if (s.isEmpty()) s=l[jj]->v;
		c->setAttributeNS(XAIRA_URIL,s_gloss,(const xairo_uchar*) s.getTerminatedBuffer());
	}
}

void CDeclarationManager::DSCAddkeyValues(FILE* f,dm_addkey* da)
{
	dm_addkeyvalue** l;
	int k=GetAddkeyValueList(da,l);
	if (k==0) return;
	UnicodeString t=da->gloss;
	if (t.isEmpty()) t=da->k;
	bool bDef=false;
	for (int jj=0;jj<k;jj++) {
		if (l[jj]->v.isEmpty()) continue;
		UnicodeString s=l[jj]->gloss;
		if (s.isEmpty()) s=l[jj]->v;
		if (l[jj]->v==da->defval) bDef=true;
		fwprintf(f,L("pos %s %s %d %s\r\n"),da->k.getTerminatedBuffer(),
			l[jj]->v.getTerminatedBuffer(),l[jj]->freq,s.getTerminatedBuffer());
	}
	mydelete [] l;
	if (da->dproc==_addkey::DP_USEVAL && !bDef) {
		fwprintf(f,L("pos %s %s 0 %s\r\n"),da->k.getTerminatedBuffer(),
			da->defval.getTerminatedBuffer(),da->defval.getTerminatedBuffer());
	}
}


void CDeclarationManager::GrammarAddkeyValues(DOMElement* e,dm_addkey* da)
{
	dm_addkeyvalue** l;
	int k=GetAddkeyValueList(da,l);
	DOMElement* cb=m_doc->createElementNS(XAIRA_URIL,s_codebook);
	Ident(cb);
	e->appendChild(cb);
	for (int jj=0;jj<k;jj++) {
		UnicodeString s=l[jj]->gloss;
		if (s.isEmpty()) s=l[jj]->v;
		DOMElement* code=m_doc->createElementNS(XAIRA_URIL,s_code);
		Ident(code);
		cb->appendChild(code);
		code->setAttributeNS(XAIRA_URIL,s_name,(const xairo_uchar*) l[jj]->v.getTerminatedBuffer());
		code->setAttributeNS(XAIRA_URIL,s_freq,_itow(l[jj]->freq,g_nb,10));
		code->setAttributeNS(XAIRA_URIL,s_gloss,(const xairo_uchar*) s.getTerminatedBuffer());
	}
	mydelete [] l;
	if (da->dproc==_addkey::DP_USEVAL) {
		DOMElement* code=m_doc->createElementNS(XAIRA_URIL,s_code);
		Ident(code);
		cb->appendChild(code);
		code->setAttributeNS(XAIRA_URIL,s_name,(const xairo_uchar*) da->defval.getTerminatedBuffer());
		code->setAttributeNS(XAIRA_URIL,s_gloss,(const xairo_uchar*) da->defval.getTerminatedBuffer());
	}
}

void CDeclarationManager::DSCRanges(FILE* f)
{
	for (int i=0;i<m_ub.GetRangeCount();i++) {
		if (m_uu[i])
			fwprintf(f,L("charset %S\r\n"),m_ub.GetRangeName(i));
	}
}


static UChar s_coderanges[]={'c','o','d','e','r','a','n','g','e','s',0};
static UChar s_charset[]={'c','h','a','r','s','e','t',0};

void CDeclarationManager::GrammarRanges(DOMElement* e)
{
	DOMElement* cr=m_doc->createElementNS(XAIRA_URIL,s_coderanges);
	e->appendChild(cr);
	for (int i=0;i<m_ub.GetRangeCount();i++) {
		if (m_uu[i]) {
			DOMElement* cs=m_doc->createElementNS(XAIRA_URIL,s_charset);
			Ident(cs);
			cr->appendChild(cs);
			xairo_uchar w[1000];
			mbstowcs(w,m_ub.GetRangeName(i),1000);
			cs->setAttributeNS(XAIRA_URIL,s_name,w);
		}
	}
}

void CDeclarationManager::DSCWBRules(FILE* f)
{
	_lang* l=m_header->m_deflang;
	if (l==NULL) return;
	if (l->bUserTokenRules) {
		fwprintf(f,L("wbrules start\r\n"));
		fwprintf(f,L("%s\r\n"),l->rules.getTerminatedBuffer());
		fwprintf(f,L("wbrules end\r\n"));
	} else 
		fwprintf(f,L("wb %S\r\n"),l->locale);
}

void CDeclarationManager::DSCTexts(FILE* f)
{
	dm_corpustext** t;
	int k=GetCorpusTextList(t);
	for (int i=0;i<k;i++) {
		fwprintf(f,L("text %s %d"),t[i]->name.getTerminatedBuffer(),t[i]->w);
		for (int j=0;j<m_header->m_ntax;j++)
			fwprintf(f,L(" %d"),t[i]->classes[j]+1);
		for (int j=0;j<m_header->m_nreg;j++) {
			fwprintf(f,L(" %d"),t[i]->nr[j]);
		}
		fwprintf(f,L("\r\n"));
	}
}

void CDeclarationManager::DSCInternalEntities(FILE* f)
{
	dm_intent** l;
	int k=GetInternalEntityList(l);
	if (k==0) {mydelete [] l; return;}
	fwprintf(f,L("# char table\r\n"));
	fwprintf(f,L("radix 16\r\n"));
	for (int i=0;i<k;i++) {
		xairo_uchar w=l[i]->v[0];
		fwprintf(f,L("char %s %04x\r\n"),l[i]->e.getTerminatedBuffer(),(int) w);
	}
	mydelete [] l;
}


static UChar s_chartable[]={'c','h','a','r','t','a','b','l','e',0};
static UChar s_radix[]={'r','a','d','i','x',0};
static UChar s_16[]={'1','6',0};
static UChar s_char[]={'c','h','a','r',0};

void CDeclarationManager::GrammarInternalEntities(DOMElement* e)
{
	dm_intent** l;
	int k=GetInternalEntityList(l);
	if (k==0) {mydelete [] l; return;}
	DOMElement* ct=m_doc->createElementNS(XAIRA_URIL,s_chartable);
	e->appendChild(ct);
	ct->setAttributeNS(XAIRA_URIL,s_radix,s_16);
	for (int i=0;i<k;i++) {
		xairo_uchar w=l[i]->v[0];
		DOMElement* ch=m_doc->createElementNS(XAIRA_URIL,s_char);
		Ident(ch);
		ct->appendChild(ch);
		ch->setAttributeNS(XAIRA_URIL,s_name,(const xairo_uchar*) l[i]->e.getTerminatedBuffer());
		ch->setAttributeNS(XAIRA_URIL,s_freq,_itow(l[i]->freq,g_nb,10));
		xairo_uchar wx[10];
		_snwprintf(wx,10,s_pc_04x,w);
		ch->setAttributeNS(XAIRA_URIL,s_code,wx);
	}
	mydelete [] l;
}


void CDeclarationManager::MakeDSC(UnicodeString path)
{
	FILE* f=_wfopen((const xairo_uchar*) path.getTerminatedBuffer(),L("wt"));
	if (f==NULL) throw(mynew CDiskCreateErr(path.getTerminatedBuffer(),strerror(errno)));
	fwprintf(f,L("ver %d\r\n"),100);
	fwprintf(f,L("# %s generated by Xaira indexer\r\n"),path.getTerminatedBuffer());
	fwprintf(f,L("option noposindex\r\n"));
	DSCLabels(f);
	DSCAddKeys(f);
	DSCLemmaSchemes(f);
	DSCRegions(f);
	DSCElements(f);
	DSCBibElements(f);
	DSCTaxonomies(f);
	DSCInternalEntities(f);
	DSCRanges(f);
	DSCTexts(f);
//	DSCWBRules(f);
	fclose(f);
}


static UChar s_xgrammar[]={'x','g','r','a','m','m','a','r',0};

void CDeclarationManager::MakeGrammar(UnicodeString path)
{
	DOMImplementation* di=DOMImplementation::getImplementation();
	UnicodeString ns(XAIRA_URI);
//	m_doc=di->createDocument((const xairo_uchar*) ns.getTerminatedBuffer(),s_xgrammar,NULL);
	m_doc=di->createDocument(XAIRA_URIL,s_xgrammar,NULL);
	DOMElement* root=m_doc->getDocumentElement();
	m_id=1;
	GrammarLabels(root);
	GrammarAddKeys(root);
	GrammarLemmaSchemes(root);
	GrammarRegions(root);
	GrammarNamespaces(root);
	GrammarElements(root);
//	GrammarBibElements(root);
	GrammarTaxonomies(root);
	GrammarInternalEntities(root);
	GrammarRanges(root);
	DOMImplementationLS* ii=(DOMImplementation*) di;
	DOMLSSerializer* w=ii->createLSSerializer();
	DOMLSOutput* lso=ii->createLSOutput();
	LocalFileFormatTarget f((const xairo_uchar*) path.getTerminatedBuffer());
	lso->setByteStream(&f);
	try {
		w->write(m_doc,lso);
	}
	catch (DOMException*)
	{
		throw(mynew CDiskCreateErr(path.getTerminatedBuffer(),"DOM writer error"));
	}
}

void CDeclarationManager::Ident(DOMElement* e)
{
	xairo_uchar id[1000];
	_snwprintf(id,1000,L("id%08X"),m_id++);
	e->setAttributeNS(XAIRA_URIL,L("id"),id);
}

int CDeclarationManager::elementcomp(const void* a,const void* b)
{
	dm_element** aa=(dm_element**) a;
	dm_element** bb=(dm_element**) b;
	return (*aa)->e.compare((*bb)->e);
}

int CDeclarationManager::valcomp(const void* a,const void* b)
{
	dm_value** aa=(dm_value**) a;
	dm_value** bb=(dm_value**) b;
	return (*aa)->v.compare((*bb)->v);
}

int CDeclarationManager::addkeyvalcomp(const void* a,const void* b)
{
	dm_addkeyvalue** aa=(dm_addkeyvalue**) a;
	dm_addkeyvalue** bb=(dm_addkeyvalue**) b;
	return (*aa)->v.compare((*bb)->v);
}


int CDeclarationManager::GetElementList(dm_element**& l)
{
	dm_declaration* d=m_list;
	int k=0;
	while (d) {
		if (d->ty==DMT_ELEMENT) k++;
		d=d->next;
	}
	l=mynew dm_element* [k];
	d=m_list; k=0;
	while (d) {
		if (d->ty==DMT_ELEMENT) l[k++]=(dm_element*) d;
		d=d->next;
	}
	qsort(l,k,sizeof (dm_element*),elementcomp);
	return k;
}

int CDeclarationManager::GetValueList(dm_attribute* da,dm_value**& l)
{
	dm_declaration* d=m_list;
	int k=0;
	while (d) {
		if (d->ty==DMT_ATTVAL && ((dm_value*) d)->a==da ) k++;
		d=d->next;
	}
	l=mynew dm_value* [k];
	d=m_list; k=0;
	while (d) {
		if (d->ty==DMT_ATTVAL && ((dm_value*) d)->a==da ) 
			l[k++]=(dm_value*) d;
		d=d->next;
	}
	qsort(l,k,sizeof (dm_value*),valcomp);
	return k;
}

int CDeclarationManager::GetAddkeyValueList(dm_addkey* da,dm_addkeyvalue**& l)
{
	dm_declaration* d=m_list;
	int k=0;
	while (d) {
		if (d->ty==DMT_ADDKEYVAL && ((dm_addkeyvalue*) d)->a==da ) k++;
		d=d->next;
	}
	l=mynew dm_addkeyvalue* [k];
	d=m_list; k=0;
	while (d) {
		if (d->ty==DMT_ADDKEYVAL && ((dm_addkeyvalue*) d)->a==da ) 
			l[k++]=(dm_addkeyvalue*) d;
		d=d->next;
	}
	qsort(l,k,sizeof (dm_addkeyvalue*),addkeyvalcomp);
	return k;
}

int CDeclarationManager::GetNamespaceList(dm_namespace**& l)
{
	dm_declaration* d=m_list;
	int k=0;
	while (d) {
		if (d->ty==DMT_NAMESPACE) k++;
		d=d->next;
	}
	l=mynew dm_namespace* [k];
	d=m_list; k=0;
	while (d) {
		if (d->ty==DMT_NAMESPACE) l[k++]=(dm_namespace*) d;
		d=d->next;
	}
//	qsort(l,k,sizeof (dm_element*),elementcomp);
	return k;
}

int CDeclarationManager::GetCorpusTextList(dm_corpustext**& l)
{
	dm_declaration* d=m_list;
	int k=0;
	while (d) {
		if (d->ty==DMT_CORPUSTEXT) k++;
		d=d->next;
	}
	l=mynew dm_corpustext* [k];
	d=m_list; k=0;
	while (d) {
		if (d->ty==DMT_CORPUSTEXT) l[k++]=(dm_corpustext*) d;
		d=d->next;
	}
	return k;
}

int CDeclarationManager::GetInternalEntityList(dm_intent**& l)
{
	dm_declaration* d=m_list;
	int k=0;
	while (d) {
		if (d->ty==DMT_INTENT) k++;
		d=d->next;
	}
	l=mynew dm_intent* [k];
	d=m_list; k=0;
	while (d) {
		if (d->ty==DMT_INTENT) l[k++]=(dm_intent*) d;
		d=d->next;
	}
//	qsort(l,k,sizeof (dm_element*),elementcomp);
	return k;
}

int CDeclarationManager::GetAttributesList(UnicodeString e,UnicodeString uri,dm_attribute**& l)
{
	dm_declaration* d=m_list;
	int k=0;
	while (d) {
		if (d->ty==DMT_ATTRIBUTE) {
			dm_attribute* da=(dm_attribute*) d;
			if (da->e==e && da->uri==uri) k++;
		}
		d=d->next;
	}
	l=mynew dm_attribute* [k];
	d=m_list; k=0;
	while (d) {
		if (d->ty==DMT_ATTRIBUTE) {
			dm_attribute* da=(dm_attribute*) d;
			if (da->e==e && da->uri==uri) l[k++]=(dm_attribute*) d;
		}
		d=d->next;
	}
//	qsort(l,k,sizeof (dm_element*),elementcomp);
	return k;
}

int CDeclarationManager::GetAddkeyList(dm_addkey**& l)
{
	dm_declaration* d=m_list;
	int k=0;
	while (d) {
		if (d->ty==DMT_ADDKEY) k++;
		d=d->next;
	}
	l=mynew dm_addkey* [k];
	d=m_list; k=0;
	while (d) {
		if (d->ty==DMT_ADDKEY) {
			l[k++]=(dm_addkey*) d;
		}
		d=d->next;
	}
//	qsort(l,k,sizeof (dm_element*),elementcomp);
	return k;
}
