// Locs.cpp: implementation of the CLocs class.
//

//////////////////////////////////////////////////////////////////////

#define _CRTDBG_MAP_ALLOC
#include "StdAfx.h"

#include "Corpus.h"
#include "Locs.h"
#include "Indexer.h"
#include "MemoryErr.h"
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

#ifdef _DEBUG
#define mynew ::new(_NORMAL_BLOCK,__FILE__,__LINE__)
#define mydelete ::delete
#else
#define mynew new
#define mydelete delete
#endif

#define NPP 2
//#define NEWP2

CLocs::CLocs(CCorpus* c)
{
	m_corpus=c;
	m_acc=NULL;
}

CLocs::~CLocs()
{
	if (m_acc) mydelete m_acc;
}

static UChar s_wb[]={'w','b',0};

void CLocs::Open(int k)
{
	m_colls=m_corpus->exppath(CCorpus::PARAM_INDEXPATH,"temp");
	m_collect=NULL;
	m_npage=NPP; m_nbite=0;
//	m_collect.open((const xairo_uchar*) m_colls.getTerminatedBuffer(),s_wb);
	m_pn=m_corpus->exppath(CCorpus::PARAM_INDEXPATH,"patch");
	m_patch=_wfopen((const xairo_uchar*) m_pn.getTerminatedBuffer(),s_wb);
	m_npatch=0;

	m_nl=0;
	m_band=k;
	m_lb=mynew locplus [m_band];
	if (m_lb==NULL) throw(CMemoryErr("locbufferp1",m_band,sizeof (locplus))); 
	m_base=0;
	m_ndf=0;
}




int CLocs::pcomp(const void* e1,const void* e2)
{
	_patch* p1=(_patch*) e1;
	_patch* p2=(_patch*) e2;
	return p1->n-p2->n;
}


void CLocs::Patch()
{
	fclose(m_patch);
	m_pb=mynew _patch[m_npatch];
	if (m_pb==NULL) throw(CMemoryErr("m_pb",m_npatch,sizeof(_patch))); 
	m_patch=_wfopen((const xairo_uchar*) m_pn.getTerminatedBuffer(),L("rbS"));
	fread(m_pb,sizeof (_patch),m_npatch,m_patch);
	qsort(m_pb,m_npatch,sizeof(_patch),pcomp);

//	m_collect.reopen(L("r+bS"));
	return;
}
	

int CLocs::Add(xara_loc l, int k, _dnode* d,int ct)
{
	locplus q;
//	assert(l.fi >= 0);
	if (k != -1) {
		assert(k < m_nl);
		if (k>=m_base) {
			m_lb[k-m_base].next=m_nl;
		} else { 
			_patch p;
			p.n=k;
			p.next=m_nl;
			int kw=fwrite(&p,sizeof p,1,m_patch);
			if (kw !=1) throw(CDiskWriteErr("patch",kw,1));
			m_npatch++;
/*			int m=k*sizeof q;
			fseek(m_collect,m,SEEK_SET);
			int n=fread(&q,sizeof q,1,m_collect);
			assert(n==1);
			fseek(m_collect,m,SEEK_SET);
//		assert(k != 307048);
			q.next=m_nl;
			fwrite(&q,sizeof q,1,m_collect);
			m_ndf++;
			fseek(m_collect,m_nl*sizeof q,SEEK_SET); 
*/		}
	}
	if (m_nl >= m_band+m_base) {
		if (m_npage == NPP) {
			if (m_collect) fclose(m_collect);
			xairo_uchar path[_MAX_PATH];
			xairo_uchar p[_MAX_PATH];
			swprintf(p,L("bite%04x"),m_nbite);
			wcscpy(path,(const xairo_uchar*) m_corpus->exppath(CCorpus::PARAM_INDEXPATH,(const UChar*) p).getTerminatedBuffer());
			m_collect=_wfopen(path,s_wb);
			if (m_collect == NULL) throw(CDiskWriteErr("temp",0,0));
			m_npage=0;
			m_nbite++;
		}
		int kw=m_band/NPP;
		int kkw=fwrite(m_lb,sizeof(locplus),kw,m_collect);
		if (kkw !=kw) throw(CDiskWriteErr("temp",kw,kkw));
		memcpy(m_lb,m_lb+kw,(m_band-kw)*sizeof(locplus));
		m_base+=kw;
		m_npage++;
	}
	locplus* p=&m_lb[m_nl-m_base];
	p->loc=l;
	p->next=-1;
//	p->home=-1;
	p->doc=m_corpus->NText();
	p->ct=ct;
	p->dn=d;
//	int t=fwrite(&p,sizeof p,1,m_collect);
//	assert(t==1);
	return m_nl++;

}


void CLocs::Close()
{
	int x=m_band/NPP; int xx=m_base;
	for (int i=0;i<NPP;i++) {
		if (m_npage == NPP) {
			if (m_collect) fclose(m_collect);
			xairo_uchar path[_MAX_PATH];
			xairo_uchar p[_MAX_PATH];
			swprintf(p,L("bite%04x"),m_nbite);
			wcscpy(path,(const xairo_uchar*) m_corpus->exppath(CCorpus::PARAM_INDEXPATH,(const UChar*) p).getTerminatedBuffer());
			m_collect=_wfopen(path,L("wb"));
			if (m_collect == NULL) throw(CDiskWriteErr("temp",0,0));
			m_npage=0;
			m_nbite++;
		}
		int t=x; if (xx+x >= m_nl) t=m_nl-xx;
		fwrite(m_lb+i*x,sizeof (locplus),t,m_collect);
		m_npage++;  
		xx+=x;
		if (xx >= m_nl) break; 
	}
	Patch();
	fclose(m_collect);
	m_bite=mynew _bite [m_nbite];
//	mydelete [] m_lb; now reused as m_bb
//	m_collect.close();
	fclose(m_patch);
}

int CLocs::Count()
{
	return m_count;
}

/*
locplus* CLocs::GetLoc(int k)
{
	static locplus p;
	__int64 m=k;
	m*=sizeof (locplus);
	m_collect1.seek(m);
	int t=m_collect1.read(&p,sizeof p,1);
	assert(t==1);
	return &p;
}


locplus* CLocs::GetLocB(int k,bool bB)
{
	int b=k/m_band;
	int p=k%m_band;
	if (b!=m_lastband) {
		if (bB) {
			__int64 m=b*m_band;
			m*=sizeof(locplus);
			m_collect1.seek(m);
			m_collect1.read(m_bb,sizeof(locplus),m_band);
			m_lastband=b;
		}
		else {
			return GetLoc(k);
		}
	}
	return &m_bb[p];
}

*/

void CLocs::MergeBites(int gran)
{
	xairo_uchar p[_MAX_PATH];
	wcscpy(p,(const xairo_uchar*) m_corpus->exppath(CCorpus::PARAM_INDEXPATH,"merge").getTerminatedBuffer());
	int k=0; int kx=0;
	for (int i=0;i<m_nb;i+=gran) {
		FILE* mf=_wfopen(p,s_wb);
		int t=m_nb-i;
		if (t>gran) t=gran;
		int x=MergeBites(i,t,mf,kx);
		fclose(mf);
		kx+=x;
		_wrename(p,m_bite[k].path);
		m_bite[k].nb=x;
		k++;
	}
	printf("                                                 \r");
	m_nb=k;
}

#define GRAN 32

// GRAN should be adjusted so that 
// (a) a big file is never needed as a bite file
// (b) GRAN is always smaller than the system max file open count

void CLocs::Merges()
{
	int ml=0;
	while (m_nb > GRAN) {
		printf("Merge cycle %d, nb=%d\n",++ml,m_nb);
		int k=m_nb/GRAN+1;
		if (k>GRAN) k=GRAN;
		MergeBites(k);
	}
}

int CLocs::MergeBites(int i0,int j,FILE* f,int sofar)
{
	locplus0* buffer=new locplus0[PS];
	int td=0; int xp=0; int tdd=0;
	for (int i=i0;i<i0+j;i++) {
		m_bite[i].fi=_wfopen(m_bite[i].path,L("rb"));
		int k=m_bite[i].nb;
		if (k > BBUFF) k=BBUFF;
		fread(m_bite[i].b,sizeof(locplus0),k,m_bite[i].fi);
		m_bite[i].nb-=k;
		m_bite[i].limit=k;
		m_bite[i].cursor=0;
		m_bite[i].bEmpty=false;
		tdd+=m_bite[i].nb;
	}
	while (true) {
		int i;
		int index=-1; int ii=-1;
		for (i=i0;i<i0+j;i++) {
			if (m_bite[i].bEmpty) continue;
			int c=m_bite[i].cursor;
			int id=m_bite[i].b[c].index ;
			if (index==-1 || id < index) {
				ii=i;
				index=id;
			}
		}
		if (ii<0) break;
		if (xp >= PS) {
			int kw=fwrite(buffer,sizeof(locplus0),xp,f);
			if (kw != xp) throw(CDiskWriteErr("bite",kw,xp));
			xp=0;
		}
		int c=m_bite[ii].cursor;
		memcpy(&buffer[xp],&m_bite[ii].b[c],sizeof(locplus0));
		xp++;
		td++;
		m_bite[ii].cursor++;
		if (m_bite[ii].cursor >= m_bite[ii].limit) {
			if (m_bite[ii].nb==0) 
				m_bite[ii].bEmpty=true;
			else {
				int k=m_bite[ii].nb;
				if (k > BBUFF) k=BBUFF;
				fread(m_bite[ii].b,sizeof(locplus0),k,m_bite[ii].fi);
				m_bite[ii].nb-=k;
				m_bite[ii].limit=k;
				m_bite[ii].cursor=0;
			}
		}
		if ((sofar+td)%1000==0) printf("%d/%d\r",sofar+td,m_kloc);
	}
	int kw=fwrite(buffer,sizeof(locplus0),xp,f);
	if (xp !=kw) throw(CDiskWriteErr("bite",kw,xp));
	for (int i=i0;i<i0+j;i++) {
		fclose(m_bite[i].fi);
		_wremove(m_bite[i].path);
	}

	return td;
}


void CLocs::SaveLoc3(int ks)
{
	Merges();
	Compress0();
	int xp=0;
	for (int i=0;i<m_nb;i++) {
		m_bite[i].fi=_wfopen(m_bite[i].path,L("rbS"));
		assert(m_bite[i].fi != NULL);
		int k=m_bite[i].nb;
		if (k > BBUFF) k=BBUFF;
		fread(m_bite[i].b,sizeof(locplus0),k,m_bite[i].fi);
		m_bite[i].nb-=k;
		m_bite[i].limit=k;
		m_bite[i].cursor=0;
		m_bite[i].bEmpty=false;
	}
	int ip=0;
	while (ip<m_kloc) {
		int i=0;
		for (i=0;i<m_nb;i++) {
			if (m_bite[i].bEmpty) continue;
			int c=m_bite[i].cursor;
			if (m_bite[i].b[c].index==ip) 
				break;
		}
		assert(i < m_nb);
		if (xp >= PS) {
			Compress1(xp,ks);
			xp=0;
		}
		int c=m_bite[i].cursor;
		memcpy(&m_inb[xp],&m_bite[i].b[c].loc,sizeof(xara_loc));
		xp++;
		ip++;
		m_bite[i].cursor++;
		if (m_bite[i].cursor >= m_bite[i].limit) {
			if (m_bite[i].nb==0) 
				m_bite[i].bEmpty=true;
			else {
				int k=m_bite[i].nb;
				if (k > BBUFF) k=BBUFF;
				fread(m_bite[i].b,sizeof(locplus0),k,m_bite[i].fi);
				m_bite[i].nb-=k;
				m_bite[i].limit=k;
				m_bite[i].cursor=0;
			}
		}
		if (ip%1000==0) printf("%d/%d\r",ip,m_kloc);
	}
	for (int i=0;i<m_nb;i++) {
		fclose(m_bite[i].fi);
		_wremove(m_bite[i].path);
	}
	printf("                                                 \r");
	if (xp) Compress1(xp,ks);
	Compress2(ks);
	mydelete [] m_bite;
}





int CLocs::lsort(const void* e1,const void* e2)
{
	locplus *p1=(locplus*) e1;
	locplus *p2=(locplus*) e2;
	return p1->index-p2->index;
}


int CLocs::StartAcc()
{
	return m_acc->New();
}

void CLocs::Fixup0()
{
	m_base=0;
	m_tb=mynew int [m_band];
	if (m_tb==NULL) throw(CMemoryErr("locbufferp2",m_band,sizeof(int))); 
//	m_bb=mynew locplus [m_band];
	m_bb=m_lb;
	if (m_bb==NULL) throw(CMemoryErr("locbufferp2",m_band,sizeof (locplus))); 
	m_pbase=0;
//	m_collect.reopen(L("rb"));
	m_ok=0;
	m_nb=(m_kloc+m_band-1)/m_band;
	OpenThread();

}

void CLocs::Fixup1()
{
//	mydelete [] m_bb;
//	mydelete [] m_bb1;
	mydelete [] m_tb;
	mydelete [] m_pb;
//	m_collect.close();
//	m_collect.remove();
	m_lastband=-1;
}

void CLocs::FUBand() 
{
	m_bband=m_band;
	if (m_bband+m_base > m_kloc) m_bband=m_kloc-m_base;
	int x=m_base/m_band;
	xairo_uchar p[_MAX_PATH];
	swprintf(p,L("bite%04x"),x);
	wcscpy(m_bite[x].path,(const xairo_uchar*) m_corpus->exppath(CCorpus::PARAM_INDEXPATH,(const UChar*) p).getTerminatedBuffer());

//	if (m_base > 0) {
//		memcpy(&m_lastrec,&m_bb[m_band-1],sizeof (locplus));
//		memcpy(&m_bb[0],&m_firstrec,sizeof(locplus));
//		m_collect.read(m_bb+1,sizeof (locplus), m_bband-1);
//	} else 
	FILE* f=_wfopen(m_bite[x].path,L("rb"));
	fread(m_bb,sizeof (locplus),m_bband,f);
	fclose(f);
//		m_collect.release(((__int64) m_bb+m_bband)*sizeof(locplus));
//	if (m_base+m_bband < m_kloc)
//		m_collect.read(&m_firstrec,sizeof (locplus),1);
	int i;
	for (i=m_pbase;i<m_npatch;i++) {
		_patch* p=&m_pb[i];
		if (p->n >= m_base+m_bband) break;
		locplus* q=&m_bb[p->n-m_base];
		q->next=p->next;
	}
	m_pbase=i;
	m_oldacc=0;
}


void CLocs::FUEndBand()
{
	for (int i=0;i<m_bband;i++)
//		m_tb[i]=m_bb[i].loc.sb; // broken by new design
		m_tb[i]=m_bb[i].dn->sbn; 
	WriteThread(m_tb,m_bband);
	qsort(m_bb,m_bband,sizeof(locplus),lsort);
	int x=m_base/m_band;
//	xairo_uchar p[_MAX_PATH];
//	swprintf(p,L("bite%04x"),x);
//	wcscpy(m_bite[x].path,(const xairo_uchar*) m_corpus->exppath(CCorpus::PARAM_INDEXPATH,(const UChar*) p).getTerminatedBuffer());
//	m_bite[x].fi=
	FILE* f=_wfopen(m_bite[x].path,s_wb);
	assert(f != NULL);
//	int k=fwrite(m_bb,sizeof(locplus),m_bband,f);
	for (int i=0;i<m_bband;i++) {
        int k=fwrite(&m_bb[i].loc,sizeof(xara_loc),1,f);
		if (k != 1) throw(CDiskWriteErr("bite",m_bband,k));
        k=fwrite(&m_bb[i].index,sizeof(int),1,f);
		if (k != 1) throw(CDiskWriteErr("bite",m_bband,k));
	}
	m_bite[x].nb=m_bband;
	fclose(f);
//	m_bite[x].fi=_wfopen(m_bite[x].path,L("rbS"));
//	assert(m_bite[x].fi != NULL);
	m_base+=m_band;
}
// save locs but only in the current band


void CLocs::FULocsBand()
{
	for (int k=0;k<m_bband;k++) {
// these may now just be done in order
		locplus* p=&m_bb[k];
		p->loc.sb=p->dn->sbn;
		p->index=p->dn->ptr0+p->ct;
		if (p->index/m_band==m_base/m_band) m_ok++;
		p->loc.seq=m_base+k;
		if (p->dn->acc) 
			m_acc->Entry(p->dn->acc-1,p->index,p->doc);
/*
// Now complete the threading pointers. 
		if (k > 0) {
			locplus* ppre;
			if (k > 0) 
				ppre=&m_bb[k-1];
			else ppre=&m_lastrec;
			_dnode* d=ppre->dn;
			p->loc.pre=d->ptr0+ppre->ct;
		} else 
			p->loc.pre=-1;
		if (k < m_bband-1) {
			locplus* pnxt;
			if (k < m_bband-1) 
				pnxt=&m_bb[k+1];
			else 
				pnxt=&m_firstrec;
			_dnode* d=pnxt->dn;
			p->loc.nxt=d->ptr0+pnxt->ct;
		} else p->loc.nxt=-1;
*/
		m_count++;

	}

	return;
}


void CLocs::Open2(int nt,CIndexer* ind)
{
	m_ind=ind;
	m_count=0;
//	UnicodeString locs=m_corpus->exppath(CCorpus::PARAM_INDEXPATH,"xdblocsu"); // not used any more
//	m_lf.open((const xairo_uchar*) locs.getTerminatedBuffer(),L("w+b")); 
//	UnicodeString coll=m_corpus->exppath(CCorpus::PARAM_INDEXPATH,L"temp");
//	m_if.open(coll.getTerminatedBuffer(),L"rb");
	m_acc=mynew CAcc(nt);
//	m_colls1=m_corpus->exppath(CCorpus::PARAM_INDEXPATH,"tempx");
//	m_collect1.open((const xairo_uchar*) m_colls1.getTerminatedBuffer(),s_wb);
}

void CLocs::Close2()
{
//	m_lf.close();
	m_ind->Log(L("stat"),L("<stat name=\"nl\">%d</stat>"),m_count);
	m_ind->Log(L("stat"),L("<stat name=\"ndf\">%d</stat>"),m_ndf);
//	Compress();
//	m_if.close();
	CloseThread();
	UnicodeString coll=m_corpus->exppath(CCorpus::PARAM_INDEXPATH,"temp");
//	m_if.remove();
	_wremove((const xairo_uchar*) m_pn.getTerminatedBuffer());
//	UnicodeString coll1=m_corpus->exppath(CCorpus::PARAM_INDEXPATH,L"temp1");
//	_wremove(coll1.getTerminatedBuffer());
}


int CLocs::Accelerate()
{
	UnicodeString path=m_corpus->exppath(CCorpus::PARAM_INDEXPATH,"xdbaccel");
	return m_acc->Save(path);
}

CAcc::CAcc(int nt)
{
	m_nt=nt;
	m_a=NULL;
	m_k=0;
	m_tail=&m_a;
//	m_tab=NULL;
}

CAcc::~CAcc()
{
	_acc* a=m_a;
	while (a) {
		mydelete [] a->tab;
		_acc* b=a->next;
		mydelete a;
		a=b;
	}
}


int CAcc::New()
{
	*m_tail=mynew _acc;
	if (m_tail==NULL) throw(CMemoryErr("acc",1,sizeof(_acc))); 
	(*m_tail)->tab=mynew int[m_nt];
	for (int i=0;i<m_nt;i++) (*m_tail)->tab[i]=-1;
	if ((*m_tail)->tab==NULL) throw(CMemoryErr("acctab",m_nt,sizeof(int))); 
	(*m_tail)->oldd=-1;
	(*m_tail)->next=NULL;
	m_tail=&((*m_tail)->next);
	return m_k++;
}

_acc* CAcc::Get(int n)
{
	_acc* a=m_a;
	while (n--) a=a->next;
	return a;
}

void CAcc::Entry(int a,int n,int d)
{
	_acc* ac=Get(a);
	while (ac->oldd+1<=d) {
		ac->tab[ac->oldd+1]=n;
		ac->oldd++;
	}
}

void CAcc::Done(int a,int n)
{
	_acc* ac=Get(a);
	while (ac->oldd+1<m_nt) {
		ac->tab[ac->oldd+1]=n;
		ac->oldd++;
	}
}



int CAcc::Save(UnicodeString path)
{
	FILE* af=iopen(path,(const UChar*) L("w+b")); 
	xara_ahdr ah;
	ah.nt=m_nt;
	ah.na=m_k;
	int kw=fwrite(&ah,sizeof ah,1,af);
	if (1 !=kw) throw(CDiskWriteErr("acc",kw,1));
	_acc* ax=m_a;
	while (ax) {
		int kw=fwrite(ax->tab,sizeof (int),m_nt,af);
		if (m_nt !=kw) throw(CDiskWriteErr("acc",kw,m_nt));
		ax=ax->next;
	}
	fclose(af);
	return m_nt;
}


void CLocs::Compress0()
{
	mydelete [] m_bb;
//	m_collect1.close();
//	m_collect1.remove();
	UnicodeString compfile=m_corpus->exppath(CCorpus::PARAM_INDEXPATH,"xdblocs");
	m_cf.open((const xairo_uchar*) compfile.getTerminatedBuffer(),L("wbS"));
	int np=(m_count+PS-1)/PS;
	m_cf.SetPageCount(np,m_count);
	int maxi=PS*sizeof(xara_loc);
	m_inb=mynew xara_loc [PS];
	m_maxo=((maxi*101)/100)+12;
	m_outb=mynew BYTE [m_maxo];
	m_csz=m_usz=0;
}


void CLocs::Compress1(int k,int ks)
{
	unsigned long d=m_maxo;
	int e=compress2(m_outb,&d,(BYTE*) m_inb,k*sizeof(xara_loc),ks);
	m_cf.writepage(m_outb,d);
	m_csz+=d;
	m_usz+=k*sizeof(xara_loc);
}

void CLocs::Compress2(int ks)
{
	m_cf.header(ks);
	mydelete [] m_inb;
	mydelete [] m_outb;
	m_cf.close();
	m_ind->Log(L("stat"),L("<stat name=\"ucs\">%I64d</stat>"),m_usz);
	m_ind->Log(L("stat"),L("<stat name=\"cs\">%I64d</stat>"),m_csz);
	int pc=(int) (m_csz*100/m_usz);
	m_ind->Log(L("stat"),L("<stat name=\"cpc\">%d%%</stat>"),pc);
}

void CLocs::OpenThread()
{
	UnicodeString coll1=m_corpus->exppath(CCorpus::PARAM_INDEXPATH,"xdbthread");
	m_tf.open(coll1.getTerminatedBuffer(),(const UChar*) s_wb);
	int np=(m_kloc+PS-1)/PS;
	m_tf.SetPageCount(np,m_kloc);
	int maxi=PS*sizeof(int);
	m_tp=mynew int [PS];
	m_maxto=((maxi*101)/100)+12;
	m_outbt=mynew BYTE [m_maxto];
	m_cszt=m_uszt=0;
	m_sopt=0;
}

void CLocs::WriteThread(int* t,int nt,bool bFlush)
{
	int sop=m_sopt; int eop=sop; int k0=0;
	while (nt+sop) {
		eop=PS;
		if (eop>sop+nt) eop=sop+nt;
		int k=eop-sop;
		for (int i=0; i<k;i++) {
			m_tp[sop+i]=t[i+k0];
		}
		if (eop==0) break;
		if (eop < PS && !bFlush) break;
		unsigned long d=m_maxto;
		int e=compress2(m_outbt,&d,(BYTE*) m_tp,eop*sizeof(int),5);
		m_tf.writepage(m_outbt,d);
		m_cszt+=d;
		m_uszt+=eop*sizeof(int);
		sop=0;
		eop=0;
		nt-=k;
		k0+=k;
	}
	m_sopt=eop;
}

void CLocs::CloseThread()
{
	WriteThread(NULL,0,true);
	m_tf.header(0);
	mydelete [] m_tp;
	mydelete [] m_outbt;
	m_tf.close();
	m_ind->Log(L("stat"),L("<stat name=\"ucst\">%I64d</stat>"),m_uszt);
	m_ind->Log(L("stat"),L("<stat name=\"cst\">%I64d</stat>"),m_cszt);
	int pc=(int) (m_cszt*100/m_uszt);
	m_ind->Log(L("stat"),L("<stat name=\"cpct\">%d%%</stat>"),pc);
}	



