// Tokeniser.cpp: implementation of the CTokeniser class.
//
//////////////////////////////////////////////////////////////////////

#define _CRTDBG_MAP_ALLOC
#include "StdAfx.h"

#include "Tokeniser.h"

#undef THIS_FILE
static char THIS_FILE[] = __FILE__;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////



CTokeniser::CTokeniser(const char* loc)
{
	UErrorCode e=U_ZERO_ERROR;
	m_bi=BreakIterator::createWordInstance(loc,e);
	assert(U_SUCCESS(e));
}

CTokeniser::~CTokeniser()
{
	delete m_bi;
}


/*
BreakIterator* bi = 

    bi->setText(s);
    UTextOffset p = bi->first();
    while (p != BreakIterator::DONE) {
        printf("Boundary at position %d\n", p);
        p = bi->next();
    }
    delete bi;
*/

void CTokeniser::SetText(UnicodeString& s)
{
	m_bi->setText(s);
	m_p=m_bi->first();
}

bool CTokeniser::GetNext(int &n)
{
	if (m_p == BreakIterator::DONE) return false;
	n=m_p;
	m_p=m_bi->next();
	return true;
}

UnicodeString CTokeniser::IndexForm(UnicodeString c)
{
	UnicodeString s1=FoldCase(c);
	UnicodeString s2=Normalize(s1);
	return s2;
}

UnicodeString CTokeniser::IndexFormCase(UnicodeString c)
{
	return Normalize(c);
}

UnicodeString CTokeniser::FoldCase(UnicodeString c)
{
	return c.foldCase();
}


#define NORM_MODE UNORM_NFKC

// we should strip some characters eg soft hyphens here
UnicodeString CTokeniser::Normalize(UnicodeString c)
{
//	XMLCh* cc=NULL;
	UErrorCode err=U_ZERO_ERROR;
//	int k=unorm_normalize(c,-1,NORM_MODE,0,cc,0,&err);
	UnicodeString cc;
	err=U_ZERO_ERROR;
	Normalizer::normalize(c,NORM_MODE,0,cc,err);
	assert (U_SUCCESS(err));
	return cc;
}


bool CTokeniser::AllSpace(const xairo_uchar* w)
{
	int i;
	for (i=0;w[i];i++)
		if (!u_isUWhiteSpace(w[i]))
			return false;
	return true;
}
