#define _CRT_SECURE_NO_DEPRECATE 1

#include <string.h>
#include <unicode/unistr.h>
#include <unicode/fmtable.h>
#include <unicode/decimfmt.h>

#include "../XairoHeader.h"

#include "Users.h"

CUsers::CUsers(void)
{
}

CUsers::~CUsers(void)
{
}

#define USERBASE "xaira_users.xml"

static UChar s_xaira_users[]={'x','a','i','r','a','_','u','s','e','r','s',0};
static UChar s_user[]={'u','s','e','r',0};
static UChar s_name[]={'n','a','m','e',0};
static UChar s_pwd[]={'p','w','d',0};
static UChar s_maxtry[]={'m','a','x','t','r','y',0};
static UChar s_download[]={'d','o','w','n','l','o','a','d',0};

bool CUsers::Init(const char* path,int& maxtry)
{
    XMLPlatformUtils::Initialize();
	char p[1028];
	strcpy(p,path);
	strcat(p,"/");
	strcat(p,USERBASE);
	static XercesDOMParser d;
	d.setDoNamespaces(true);
	d.parse(p);
	if (d.getErrorCount()>0) return false;
	m_doc=d.getDocument();
	DOMElement* el=m_doc->getDocumentElement();
	UnicodeString tag=el->getTagName();
	if (tag!=s_xaira_users)  
		return false;
	Param(s_maxtry,maxtry);
	m_download[0]=0;
	ParamS(s_download,m_download,MAXP);
	return true;
}

const char* CUsers::getDownload()
{
	return m_download;
}

void CUsers::Param(const UChar* name,int& x)
{
	DOMElement* el=m_doc->getDocumentElement();
	DOMNodeList* l=el->getElementsByTagName(name);
	UnicodeString nn, pp; 
	int k=l->getLength();
	if (k==0) return;
	DOMElement* e=(DOMElement*) l->item(0);
	const UChar* n=e->getTextContent();
	UErrorCode(err);
	DecimalFormat df(err);
	Formattable f;
	ParsePosition ppos;
	df.parse(n,f,ppos);
	x=f.getLong();
}

void CUsers::ParamS(const UChar* name,char* buff,int maxb)
{
	DOMElement* el=m_doc->getDocumentElement();
	DOMNodeList* l=el->getElementsByTagName(name);
	UnicodeString nn, pp; 
	int k=l->getLength();
	if (k==0) return;
	DOMElement* e=(DOMElement*) l->item(0);
	UnicodeString n=e->getTextContent();
	UErrorCode err;
	n.extract(buff,maxb,NULL,err);
}

bool CUsers::Lookup(const char* name,const char* pwd)
{
	DOMElement* el=m_doc->getDocumentElement();
	DOMNodeList* l=el->getElementsByTagName(s_user);
	UnicodeString nn, pp; 
	int k=l->getLength();
	for (int i=0;i<k;i++) {
		DOMElement* e=(DOMElement*) l->item(i);
		DOMNodeList* ll=e->getChildNodes();
		int kk=ll->getLength();
		for (int j=0;j<kk;j++) {
			DOMNode* u=ll->item(j);
			if (u->getNodeType() != DOMNode::ELEMENT_NODE) continue;
			DOMElement* ue = (DOMElement*) u;
			UnicodeString t=ue->getTagName();
			if (t==s_name) nn=ue->getTextContent();
			else if (t==s_pwd) pp=ue->getTextContent();
		}
		if (nn==name && pp==pwd) return true;
	}
	return false;
}

