#pragma once

class CXairaTestHarness
{
public:
	CXairaTestHarness(void);
	~CXairaTestHarness(void);
	void exec(const char*,CXairoInterface* s,bool);
	int status();
private:
	CXairoInterface* m_server;
	int m_status; int m_nerr;
	XercesDOMParser m_parser;
	XERCES_CPP_NAMESPACE::DOMDocument *m_doc;
	XERCES_CPP_NAMESPACE::DOMDocument *m_cdoc;
	void Log(const char*,...);
	bool Calibrate(const char*);
	void Test();
	bool CalibName(char*,const char*,int);
	void SetStatus(int s) {m_status=s;}
	bool Init(const char*);
	bool InitCal(const char*);
	DOMElement* EvalTest(DOMElement*);
	void CalRecord(DOMElement*,DOMElement*);
	void EvalRecord(DOMElement*,DOMElement*);
	void Comp(DOMElement*,DOMElement*,XMLSize_t,const char*);
	UnicodeString NormSpace(UnicodeString s);

};
